From bb1dfdec467af6ca497874496b33c875509f6d3c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 15 2020 03:58:42 +0000
Subject: [PATCH 1387/2232] Improve resilience to changes in filetype from dir to file


---

diff --git a/gen/build/src/out.rs b/gen/build/src/out.rs
index 157b316..e275049 100644
--- a/gen/build/src/out.rs
+++ b/gen/build/src/out.rs
@@ -14,7 +14,7 @@ pub(crate) fn write(path: impl AsRef<Path>, content: &[u8]) -> Result<()> {
                 return Ok(());
             }
         }
-        let _ = fs::remove_file(path);
+        best_effort_remove(path);
     } else {
         let parent = path.parent().unwrap();
         create_dir_error = fs::create_dir_all(parent).err();
@@ -34,7 +34,7 @@ pub(crate) fn symlink_file(original: impl AsRef<Path>, link: impl AsRef<Path>) -
 
     let mut create_dir_error = None;
     if link.exists() {
-        let _ = fs::remove_file(link).unwrap();
+        best_effort_remove(link);
     } else {
         let parent = link.parent().unwrap();
         create_dir_error = fs::create_dir_all(parent).err();
@@ -54,7 +54,7 @@ pub(crate) fn symlink_dir(original: impl AsRef<Path>, link: impl AsRef<Path>) ->
 
     let mut create_dir_error = None;
     if link.exists() {
-        let _ = paths::remove_symlink_dir(link).unwrap();
+        best_effort_remove(link);
     } else {
         let parent = link.parent().unwrap();
         create_dir_error = fs::create_dir_all(parent).err();
@@ -67,3 +67,28 @@ pub(crate) fn symlink_dir(original: impl AsRef<Path>, link: impl AsRef<Path>) ->
         Err(err) => Err(Error::Fs(create_dir_error.unwrap_or(err))),
     }
 }
+
+fn best_effort_remove(path: &Path) {
+    use std::fs;
+
+    let file_type = match if cfg!(windows) {
+        // On Windows, the correct choice of remove_file vs remove_dir needs to
+        // be used according to what the symlink *points to*. Trying to use
+        // remove_file to remove a symlink which points to a directory fails
+        // with "Access is denied".
+        fs::metadata(path)
+    } else {
+        // On non-Windows, we check metadata not following symlinks. All
+        // symlinks are removed using remove_file.
+        fs::symlink_metadata(path)
+    } {
+        Ok(metadata) => metadata.file_type(),
+        Err(_) => return,
+    };
+
+    if file_type.is_dir() {
+        let _ = fs::remove_dir_all(path);
+    } else {
+        let _ = fs::remove_file(path);
+    }
+}
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index effeec2..c514a57 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -65,11 +65,3 @@ pub(crate) fn symlink_or_copy(
     fs::copy(original, copy)?;
     Ok(())
 }
-
-#[cfg(not(windows))]
-pub(crate) use self::fs::remove_file as remove_symlink_dir;
-
-// On Windows, trying to use remove_file to remove a symlink which points to a
-// directory fails with "Access is denied".
-#[cfg(windows)]
-pub(crate) use self::fs::remove_dir as remove_symlink_dir;

